import { type ReactNode } from 'react';
import { type ButtonProps, type LinkProps } from 'react-aria-components';
export declare const buttonResetStyles: string;
export type ButtonProperties = (ButtonProps | LinkProps) & {
    readonly className?: string;
    readonly children?: ReactNode;
    readonly variant?: 'stripped' | 'primary' | 'secondary';
    readonly iconLeft?: ReactNode;
    readonly iconRight?: ReactNode;
    readonly isLoading?: boolean;
    readonly isSkeleton?: boolean;
    readonly hasMovingGradients?: boolean;
    readonly movingGradientsCount?: number;
    readonly hasMovingStars?: boolean;
    readonly movingStarsCount?: number;
};
export default function Button({ className, children: inputChildren, variant, iconLeft, iconRight, isLoading, isSkeleton, hasMovingGradients, movingGradientsCount, hasMovingStars, movingStarsCount, ...properties }: ButtonProperties): ReactNode;
