"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = LoadingSpinner;
const react_1 = __importDefault(require("react"));
const react_aria_components_1 = require("react-aria-components");
const core_1 = require("@kuma-ui/core");
const cx_1 = __importDefault(require("../utilities/cx"));
function LoadingSpinner(_a) {
    var { className, size = 20, strokeWidth = 2.5 } = _a, properties = __rest(_a, ["className", "size", "strokeWidth"]);
    const radius = size / 2;
    const curve = 2 * (radius - strokeWidth) * Math.PI;
    return (react_1.default.createElement(react_aria_components_1.ProgressBar, Object.assign({}, properties, { value: 70, className: (0, cx_1.default)((0, core_1.css) `
					--color: #000;
					text-align: center;
					display: inline-flex;

					:where([data-theme='dark']) & {
						--color: #fff;
					}
				`, className), style: { width: size, height: size } }), ({ percentage }) => (react_1.default.createElement("svg", { width: size, height: size, preserveAspectRatio: "xMaxYMax meet", viewBox: `0 0 ${size} ${size}`, fill: "none", strokeWidth: strokeWidth, className: (0, core_1.css) `
						@keyframes loading-spinner {
							0% {
								transform: rotate(0deg);
							}

							100% {
								transform: rotate(359deg);
							}
						}

						animation: loading-spinner 1s linear infinite;
					` },
        react_1.default.createElement("circle", { cx: radius, cy: radius, r: radius - strokeWidth, stroke: "var(--color)", strokeDasharray: `${curve} ${curve}`, strokeDashoffset: curve - ((percentage !== null && percentage !== void 0 ? percentage : 100) / 100) * curve, strokeLinecap: "round" })))));
}
