"use strict";
'use client';
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Revealer;
const react_1 = __importStar(require("react"));
const core_1 = require("@kuma-ui/core");
const cx_1 = __importDefault(require("../utilities/cx"));
function Revealer(_a) {
    var { delay = 1, animationDelay = 1, duration = 555, threshold = 0.3, distance = 20, isMoving = true, isCentered = false, canReveal = true, children, className } = _a, properties = __rest(_a, ["delay", "animationDelay", "duration", "threshold", "distance", "isMoving", "isCentered", "canReveal", "children", "className"]);
    const reference = (0, react_1.useRef)(null);
    const [internalCanReveal, setInternalCanReveal] = (0, react_1.useState)(false);
    const [isVisible, setIsVisible] = (0, react_1.useState)(() => typeof window === 'undefined' ? false : !('IntersectionObserver' in window));
    (0, react_1.useEffect)(() => {
        const timeout = setTimeout(() => {
            setInternalCanReveal(true);
        }, delay);
        return () => {
            clearTimeout(timeout);
        };
    }, [delay]);
    (0, react_1.useEffect)(() => {
        if (internalCanReveal && canReveal && !isVisible && reference.current) {
            const observer = new IntersectionObserver((entries) => {
                if (entries.some((entry) => entry.isIntersecting)) {
                    requestAnimationFrame(() => {
                        setIsVisible(true);
                    });
                }
            }, { threshold });
            observer.observe(reference.current);
            return () => {
                observer.disconnect();
            };
        }
    }, [internalCanReveal, canReveal, isVisible, threshold]);
    return (react_1.default.createElement("div", Object.assign({}, properties, { ref: reference, className: (0, cx_1.default)((0, core_1.css) `
					opacity: 0;
					transition:
						transform var(--duration) var(--animation-delay),
						opacity var(--duration) var(--animation-delay);
				`, isMoving &&
            (0, core_1.css) `
						transform: translate3d(0, var(--distance), 0);

						@media (prefers-reduced-motion) {
							transform: translate3d(0, calc(var(--distance) / 3));
						}
					`, isVisible &&
            (0, core_1.css) `
						transform: translate3d(0, 0, 0);
						opacity: 1;
					`, isCentered &&
            (0, core_1.css) `
						width: 100%;
						margin: auto;
					`, className), style: {
            '--distance': `${distance}px`,
            '--duration': `${duration / 1000}s`,
            '--animation-delay': `${animationDelay / 1000}s`,
        } }), children));
}
