"use strict";
'use client';
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SkeletonInstance = SkeletonInstance;
exports.default = Skeleton;
const react_1 = __importStar(require("react"));
const core_1 = require("@kuma-ui/core");
const cx_1 = __importDefault(require("../utilities/cx"));
function SkeletonInstance(_a) {
    var { width, height, className, children, isAnimated = true } = _a, parameters = __rest(_a, ["width", "height", "className", "children", "isAnimated"]);
    return (react_1.default.createElement("span", Object.assign({}, parameters, { "aria-busy": true, "aria-role": "progressbar", className: (0, cx_1.default)((0, core_1.css) `
					--size: 300px;
					--negative-size: calc(var(--size) * -1);

					@keyframes skeleton-animation {
						0% {
							background-position: var(--negative-size) 0%;
						}

						100% {
							background-position: right var(--negative-size) top 0%;
						}
					}

					background: rgba(0, 0, 0, 0.15);
					width: 100%;
					border-radius: 100px;
					animation: skeleton-animation 1.1s infinite ease-in-out;
					will-change: background-position;
					display: inline-block;
					vertical-align: top;

					:where([data-theme='dark']) & {
						background-color: rgba(255, 255, 255, 0.2);
					}
				`, isAnimated &&
            (0, core_1.css) `
						--opacity: 0.3;
						background-position: var(--negative-size) 0%;
						background-attachment: fixed;
						background-size: var(--size) 100%;
						background-repeat: no-repeat;
						background-image: linear-gradient(
							90deg,
							rgba(255, 255, 255, 0) 0%,
							rgba(255, 255, 255, var(--opacity)) 50%,
							rgba(255, 255, 255, 0) 100%
						);

						:where([data-theme='dark']) & {
							--opacity: 0.08;
						}
					`, className), style: { width, height } }), children !== null && children !== void 0 ? children : react_1.default.createElement(react_1.default.Fragment, null, "\u00A0")));
}
const skeletonLinesStyles = (0, core_1.css) `
	vertical-align: middle;
`;
function Skeleton({ lines = 1 }) {
    const fullwidthLines = (0, react_1.useMemo)(() => {
        const elements = [];
        if (lines <= 1) {
            return elements;
        }
        for (let iteration = 0; iteration < lines; iteration += 1) {
            elements.push(react_1.default.createElement(SkeletonInstance, { key: iteration, width: "100%", height: "1em", className: skeletonLinesStyles }));
        }
        return elements;
    }, [lines]);
    return lines === 1 ? (react_1.default.createElement(SkeletonInstance, { width: "100%", height: "1em", className: skeletonLinesStyles })) : (react_1.default.createElement(react_1.default.Fragment, null,
        fullwidthLines,
        react_1.default.createElement(SkeletonInstance, { width: "60%", height: "1em", className: skeletonLinesStyles })));
}
