"use strict";
'use client';
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.themePreferences = void 0;
exports.useTheme = useTheme;
exports.getThemePreference = getThemePreference;
exports.setThemePreference = setThemePreference;
exports.default = ThemeSetter;
const react_1 = __importStar(require("react"));
exports.themePreferences = ['system', 'light', 'dark'];
function useTheme() {
    const [theme, setTheme] = (0, react_1.useState)('light');
    (0, react_1.useEffect)(() => {
        const listener = () => {
            if (document.documentElement.dataset.theme) {
                setTheme(document.documentElement.dataset.theme);
            }
        };
        const observer = new MutationObserver((mutations) => {
            for (const mutation of mutations) {
                if (mutation.type === 'attributes') {
                    listener();
                }
            }
        });
        listener();
        observer.observe(document.documentElement, { attributes: true });
        return () => {
            observer.disconnect();
        };
    }, []);
    return theme;
}
const script = `
	try {
		var themePreference = window.localStorage.getItem("theme-preference") || "system";
		
		if (themePreference) {
			document.documentElement.setAttribute("data-theme-preference", themePreference);
		}

		var query = window.matchMedia("(prefers-color-scheme: dark)");

		document.documentElement.setAttribute(
			"data-theme", 
			(themePreference === "system") 
				? query.matches ? "dark" : "light" 
				: themePreference
		);
	} catch (error) {
		console.error(error);
	}
`
    .trim()
    .replaceAll(/\s+/g, ' ');
function getThemePreference() {
    var _a;
    const preference = (_a = window.localStorage.getItem('theme-preference')) !== null && _a !== void 0 ? _a : 'system';
    return exports.themePreferences.includes(preference) ? preference : 'system';
}
function setThemePreference(preference) {
    const themePreference = exports.themePreferences.includes(preference)
        ? preference
        : 'system';
    window.localStorage.setItem('theme-preference', themePreference);
    document.documentElement.dataset.themePreference = themePreference;
    if (themePreference === 'system') {
        const query = window.matchMedia('(prefers-color-scheme: dark)');
        document.documentElement.dataset.theme = query.matches ? 'dark' : 'light';
    }
    else {
        document.documentElement.dataset.theme = themePreference;
    }
}
function ThemeSetter() {
    (0, react_1.useEffect)(() => {
        const themePreference = getThemePreference();
        if (themePreference) {
            document.documentElement.dataset.themePreference = themePreference;
        }
        const observer = window.matchMedia('(prefers-color-scheme: dark)');
        if (themePreference === 'system') {
            document.documentElement.dataset.theme = observer.matches
                ? 'dark'
                : 'light';
        }
        else {
            document.documentElement.dataset.theme = themePreference;
        }
        const listener = (query) => {
            if (document.documentElement.dataset.themePreference === 'system') {
                document.documentElement.dataset.theme = query.matches
                    ? 'dark'
                    : 'light';
            }
        };
        observer.addEventListener('change', listener);
        return () => {
            observer.removeEventListener('change', listener);
        };
    }, []);
    return (
    /* eslint-disable-next-line react/no-danger */
    react_1.default.createElement("script", { dangerouslySetInnerHTML: { __html: script }, id: "theme-setter" }));
}
