"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFetcherError = isFetcherError;
function isFetcherError(error) {
    return 'isFetcherError' in error && error.isFetcherError === true;
}
const fetcher = (property) => (url, options) => __awaiter(void 0, void 0, void 0, function* () {
    return fetch(url, options)
        .then((response) => __awaiter(void 0, void 0, void 0, function* () { return response.json(); }))
        .then((response) => {
        if (response.success) {
            return response[property];
        }
        const error = new Error(response.error.message);
        error.isFetcherError = true;
        error.type = response.error.type;
        error.code = response.error.code;
        throw error;
    });
});
exports.default = fetcher;
